{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2019 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnTestToolBarImageFix;
{ |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* Ԫƣ༭޸IDEͼʾ
* ԪߣCnPack 
*     עõԪǱ༭ⲿĸԵԪBDSϰ汾ִ
* ƽ̨PWin2000Pro + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 + C++Builder 5/6
*   ôеַݲֱ֧ػʽ
* ޸ļ¼2014.09.22 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{$I CnWizards.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolsAPI, IniFiles, StdCtrls, ComCtrls, TypInfo, CnWizIdeUtils, CnWizManager,
  CnWizClasses, CnWizUtils, CnWizConsts, CnEditControlWrapper;

type

//==============================================================================
// ༭޸ͼʾĲ˵ר
//==============================================================================

{ TCnTestToolBarImageFix }

  TCnTestToolBarImageFix = class(TCnMenuWizard)
  private

  protected
    function GetHasConfig: Boolean; override;
  public
    function GetState: TWizardState; override;
    procedure Config; override;
    procedure LoadSettings(Ini: TCustomIniFile); override;
    procedure SaveSettings(Ini: TCustomIniFile); override;
    class procedure GetWizardInfo(var Name, Author, Email, Comment: string); override;
    function GetCaption: string; override;
    function GetHint: string; override;
    function GetDefShortCut: TShortCut; override;
    procedure Execute; override;

    destructor Destroy; override;
  end;

implementation

uses
  CnDebug;

//==============================================================================
// ༭޸ͼʾĲ˵ר
//==============================================================================

{ TCnTestIdeTookBarFix }

procedure TCnTestToolBarImageFix.Config;
begin
  ShowMessage('Test option.');
  { TODO -oAnyone : ڴʾô }
end;

destructor TCnTestToolBarImageFix.Destroy;
begin
  inherited;
end;

procedure TCnTestToolBarImageFix.Execute;
var
  BrowserToolbar: TToolBar;
  ToolbarParent: TWinControl;
  P: TPoint;
  Wizard: TCnBaseWizard;
begin
  BrowserToolbar := TToolBar(GetIdeMainForm.FindComponent('BrowserToolBar'));
  if BrowserToolbar <> nil then
  begin
    CnDebugger.LogFmt('BrowserToolbar Top %d Left %d Width %d Height %d',
      [BrowserToolbar.Top, BrowserToolbar.Left, BrowserToolbar.Width, BrowserToolbar.Height]);

    ToolbarParent := BrowserToolbar.Parent;
    if ToolbarParent <> nil then
    begin
    CnDebugger.LogFmt('ToolbarParent Top %d Left %d Width %d Height %d',
      [ToolbarParent.Top, ToolbarParent.Left, ToolbarParent.Width, ToolbarParent.Height]);

      P.X := 5;
      P.Y := BrowserToolbar.Height div 2;
      P := BrowserToolbar.ClientToParent(P);
      CnDebugger.LogPoint(P, 'Click in Parent.');

      Wizard := CnWizardMgr.WizardByClassName('TCnPaletteEnhanceWizard');
      if Wizard <> nil then
      try
        SetPropValue(Wizard, 'TempDisableLock', True);
      except
        CnDebugger.LogMsg('Error set TempDisableLock True');
      end;
      SendMessage(ToolbarParent.Handle, WM_LBUTTONDOWN, 0, MakeLParam(P.X, P.Y));
      SendMessage(ToolbarParent.Handle, WM_MOUSEMOVE, 0, MakeLParam(P.X + 1, P.Y));
      SendMessage(ToolbarParent.Handle, WM_MOUSEMOVE, 0, MakeLParam(P.X, P.Y));
      SendMessage(ToolbarParent.Handle, WM_LBUTTONUP, 0, MakeLParam(P.X, P.Y));
      if Wizard <> nil then
      try
        SetPropValue(Wizard, 'TempDisableLock', False);
      except
        CnDebugger.LogMsg('Error set TempDisableLock False');
      end;
    end;
  end;
  { TODO -oAnyone : רҵִй }
end;

function TCnTestToolBarImageFix.GetCaption: string;
begin
  Result := 'Fix IDE Toolbar Image';
  { TODO -oAnyone : רҲ˵ı⣬ַбػ }
end;

function TCnTestToolBarImageFix.GetDefShortCut: TShortCut;
begin
  Result := 0;
  { TODO -oAnyone : ĬϵĿݼ }
end;

function TCnTestToolBarImageFix.GetHasConfig: Boolean;
begin
  Result := False;
  { TODO -oAnyone : רǷô }
end;

function TCnTestToolBarImageFix.GetHint: string;
begin
  Result := 'Register an Editor ToolBar Type';
  { TODO -oAnyone : רҲ˵ʾϢַбػ }
end;

function TCnTestToolBarImageFix.GetState: TWizardState;
begin
  Result := [wsEnabled];
  { TODO -oAnyone : רҲ˵״̬ɸָ趨 }
end;

class procedure TCnTestToolBarImageFix.GetWizardInfo(var Name, Author, Email, Comment: string);
begin
  Name := 'TestToolBarImageFix';
  Author := 'CnPack Team';
  Email := 'master@cnpack.org';
  Comment := 'Test Fix IDE Toolbar Image';
  { TODO -oAnyone : רҵơߡ估עַбػ }
end;

procedure TCnTestToolBarImageFix.LoadSettings(Ini: TCustomIniFile);
begin
  { TODO -oAnyone : ڴװרڲõĲרҴʱԶ }
end;

procedure TCnTestToolBarImageFix.SaveSettings(Ini: TCustomIniFile);
begin
  { TODO -oAnyone : ڴ˱רڲõĲרͷʱԶ }
end;

initialization
  RegisterCnWizard(TCnTestToolBarImageFix); // ער

end.
